/* Copyright (C) 2014 by John Cronin
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:

 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.

 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#ifndef EWCOLOR_H
#define EWCOLOR_H

#define EW_BLACK 0xFF000000
#define EW_DIMGRAY 0xFF696969
#define EW_GRAY 0xFF808080
#define EW_DARKGRAY 0xFFA9A9A9
#define EW_SILVER 0xFFC0C0C0
#define EW_LIGHTGREY 0xFFD3D3D3
#define EW_GAINSBORO 0xFFDCDCDC
#define EW_WHITESMOKE 0xFFF5F5F5
#define EW_GHOSTWHITE 0xFFF8F8FF
#define EW_WHITE 0xFFFFFFFF
#define EW_SLATEGRAY 0xFF708090
#define EW_LIGHTSLATEGRAY 0xFF778899
#define EW_MIDNIGHTBLUE 0xFF191970
#define EW_NAVY 0xFF000080
#define EW_DARKBLUE 0xFF00008B
#define EW_DARKSLATEBLUE 0xFF483D8B
#define EW_MEDIUMBLUE 0xFF0000CD
#define EW_BLUE 0xFF0000FF
#define EW_STEELBLUE 0xFF4682B4
#define EW_ROYALBLUE 0xFF4169E1
#define EW_CORNFLOWERBLUE 0xFF6495ED
#define EW_DODGERBLUE 0xFF1E90FF
#define EW_DEEPSKYBLUE 0xFF00BFFF
#define EW_LIGHTSKYBLUE 0xFF87CEFA
#define EW_SKYBLUE 0xFF87CEEB
#define EW_LIGHTSTEELBLUE 0xFFB0C4DE
#define EW_LIGHTBLUE 0xFFADD8E6
#define EW_POWDERBLUE 0xFFB0E0E6
#define EW_PALETURQUOISE 0xFFAFEEEE
#define EW_LIGHTCYAN 0xFFE0FFFF
#define EW_ALICEBLUE 0xFFF0F8FF
#define EW_AZURE 0xFFF0FFFF
#define EW_MINTCREAM 0xFFF5FFFA
#define EW_DARKSLATEGRAY 0xFF2F4F4F
#define EW_CADETBLUE 0xFF5F9EA0
#define EW_TEAL 0xFF008080
#define EW_DARKCYAN 0xFF008B8B
#define EW_LIGHTSEAGREEN 0xFF20B2AA
#define EW_DARKTURQUOISE 0xFF00CED1
#define EW_MEDIUMTURQUOISE 0xFF48D1CC
#define EW_TURQUOISE 0xFF40E0D0
#define EW_AQUA 0xFF00FFFF
#define EW_CYAN 0xFF00FFFF
#define EW_MEDIUMAQUAMARINE 0xFF66CDAA
#define EW_AQUAMARINE 0xFF7FFFD4
#define EW_DARKOLIVEGREEN 0xFF556B2F
#define EW_OLIVE 0xFF808000
#define EW_OLIVEDRAB 0xFF6B8E23
#define EW_DARKKHAKI 0xFFBDB76B
#define EW_DARKGREEN 0xFF006400
#define EW_GREEN 0xFF008000
#define EW_FORESTGREEN 0xFF228B22
#define EW_SEAGREEN 0xFF2E8B57
#define EW_MEDIUMSEAGREEN 0xFF3CB371
#define EW_DARKSEAGREEN 0xFF8FBC8F
#define EW_MEDIUMSPRINGGREEN 0xFF00FA9A
#define EW_SPRINGGREEN 0xFF00FF7F
#define EW_PALEGREEN 0xFF98FB98
#define EW_HONEYDEW 0xFFF0FFF0
#define EW_LIMEGREEN 0xFF32CD32
#define EW_LIME 0xFF00FF00
#define EW_LIGHTGREEN 0xFF90EE90
#define EW_LAWNGREEN 0xFF7CFC00
#define EW_CHARTREUSE 0xFF7FFF00
#define EW_GREENYELLOW 0xFFADFF2F
#define EW_YELLOWGREEN 0xFF9ACD32
#define EW_INDIGO 0xFF4B0082
#define EW_PURPLE 0xFF800080
#define EW_DARKMAGENTA 0xFF8B008B
#define EW_DARKVIOLET 0xFF9400D3
#define EW_DARKORCHID 0xFF9932CC
#define EW_MEDIUMORCHID 0xFFBA55D3
#define EW_ORCHID 0xFFDA70D6
#define EW_VIOLET 0xFFEE82EE
#define EW_PLUM 0xFFDDA0DD
#define EW_THISTLE 0xFFD8BFD8
#define EW_BLUEVIOLET 0xFF8A2BE2
#define EW_MEDIUMPURPLE 0xFF9370DB
#define EW_SLATEBLUE 0xFF6A5ACD
#define EW_MEDIUMSLATEBLUE 0xFF7B68EE
#define EW_LAVENDER 0xFFFFF0F5
#define EW_MEDIUMVIOLETRED 0xFFC71585
#define EW_MAGENTA 0xFFFF00FF
#define EW_FUCHSIA 0xFFFF00FF
#define EW_DEEPPINK 0xFFFF1493
#define EW_PALEVIOLETRED 0xFFDB7093
#define EW_HOTPINK 0xFFFF69B4
#define EW_LIGHTPINK 0xFFFFB6C1
#define EW_PINK 0xFFFFC0CB
#define EW_MISTYROSE 0xFFFFE4E1
#define EW_LAVENDERBLUSH 0xFFE6E6FA
#define EW_MAROON 0xFF800000
#define EW_DARKRED 0xFF8B0000
#define EW_FIREBRICK 0xFFB22222
#define EW_CRIMSON 0xFFDC143C
#define EW_RED 0xFFFF0000
#define EW_ORANGERED 0xFFFF4500
#define EW_TOMATO 0xFFFF6347
#define EW_INDIANRED 0xFFCD5C5C
#define EW_LIGHTCORAL 0xFFF08080
#define EW_SALMON 0xFFFA8072
#define EW_DARKSALMON 0xFFE9967A
#define EW_LIGHTSALMON 0xFFFFA07A
#define EW_CORAL 0xFFFF7F50
#define EW_DARKORANGE 0xFFFF8C00
#define EW_ORANGE 0xFFFFA500
#define EW_SANDYBROWN 0xFFF4A460
#define EW_DARKGOLDENROD 0xFFB8860B
#define EW_GOLDENROD 0xFFDAA520
#define EW_GOLD 0xFFFFD700
#define EW_YELLOW 0xFFFFFF00
#define EW_KHAKI 0xFFF0E68C
#define EW_PALEGOLDENROD 0xFFEEE8AA
#define EW_LEMONCHIFFON 0xFFFFFACD
#define EW_CORNSILK 0xFFFFF8DC
#define EW_LIGHTGOLDENRODYELLOW 0xFFFAFAD2
#define EW_BEIGE 0xFFF5F5DC
#define EW_LIGHTYELLOW 0xFFFFFFE0
#define EW_IVORY 0xFFFFFFF0
#define EW_ROSYBROWN 0xFFBC8F8F
#define EW_SADDLEBROWN 0xFF8B4513
#define EW_BROWN 0xFFA52A2A
#define EW_SIENNA 0xFFA0522D
#define EW_CHOCOLATE 0xFFD2691E
#define EW_PERU 0xFFCD853F
#define EW_TAN 0xFFD2B48C
#define EW_BURLYWOOD 0xFFDEB887
#define EW_WHEAT 0xFFF5DEB3
#define EW_NAVAJOWHITE 0xFFFFDEAD
#define EW_PEACHPUFF 0xFFFFDAB9
#define EW_MOCCASIN 0xFFFFE4B5
#define EW_BISQUE 0xFFFFE4C4
#define EW_BLANCHEDALMOND 0xFFFFEBCD
#define EW_PAPAYAWHIP 0xFFFFEFD5
#define EW_ANTIQUEWHITE 0xFFFAEBD7
#define EW_LINEN 0xFFFAF0E6
#define EW_OLDLACE 0xFFFDF5E6
#define EW_SEASHELL 0xFFFFF5EE
#define EW_FLORALWHITE 0xFFFFFAF0
#define EW_SNOW 0xFFFFFAFA

#define EW_ALPHA0		0
#define EW_ALPHA10		25
#define EW_ALPHA20		51
#define EW_ALPHA30		76
#define EW_ALPHA40		102
#define EW_ALPHA50		127
#define EW_ALPHA60		153
#define EW_ALPHA70		178
#define EW_ALPHA80		204
#define EW_ALPHA90		229
#define EW_ALPHA25		63
#define EW_ALPHA75		191

#define EW_MAKECOLOR(col, alpha)		(((col) & 0xffffff) | ((alpha) << 24))

#endif
